/*
 * UIText.cpp
 *
 *  Created on: May 21, 2020
 *      Author: ayoungblood
 */

#include "UIText.h"
#include "../game/Game.hpp"
#include "../ecs/ECS.h"
#include "../ecs/Components.h"
#include "string.h"
#include <iostream>
#include <stdio.h>
#include <vector>

extern Manager manager;

UIText::UIText(std::string text, std::string texId, int x, int y, int letterW, int letterH, int lScale)
{
	inputText = text;
	textureID = texId;
	posX = x;
	posY = y;
	letterWidth = letterW;
	letterHeight = letterH;
	scale = lScale;
}

UIText::~UIText()
{
}

void UIText::ParseString(std::string inputText, int x, int y, int letterScale, std::string tag, Game::groupLabels group)
{
	//Parse input text into an array of char
	int posX = x;
	int posY = y;
	int i = 0;
	char current = inputText[i];

	do
	{
		++i;
		if (strcmp(&current,"\n")!=0)
		{
			posX += letterWidth;
		}
		else
		{
			posX = x;
			posY += letterHeight;
		}
		UIText::AddLetter(posX, posY, current, tag, letterScale, group);
		current = inputText[i];
	} while ((strcmp(&current,"\0"))!=0);
}


void UIText::AddLetter(int xpos, int ypos, char crnt, std::string tag, int lttrScale, Game::groupLabels groupLabel)
{
	auto& letter(manager.addEntity());
	letter.addComponent<TransformComponent>(xpos*lttrScale, ypos*lttrScale, letterWidth, letterHeight, 1);
	letter.addComponent<SpriteComponent>("font", SpriteComponent::spriteText, crnt, letterWidth, letterHeight, lttrScale);
    letter.setTag(tag);
	letter.addGroup(groupLabel);
}

void UIText::RemoveAllLetters()
{
    manager.getEntitiesByTag("");
}

